#!/bin/sh
KERNVER="`uname -r`"
#110123 If drivers not installed, remove init script (to avoid wait timeout if triggered by udev rule) and exit...
[ "`ls /lib/modules/$KERNVER/hsfmodem 2>/dev/null`" = "" ] \
 && rm -f /etc/init.d/hsfmodem 2>/dev/null | /bin/true \
 && exit

#Indicate not configured - script waits for it.
rm -f /etc/hsfmodem/.serial_configured

#Generate blacklist of conflicting modules.  Add 'install' statements to ensure module not loaded. Special 'modemx_' blacklist config file removed by modemprobe_erase #120905...
/usr/sbin/hsfmodconflicts /lib/modules/$(uname -r) | sed -e 's%^\([a-z0-9_\-]*\)\(.*\)%blacklist \1 # temporarily disabled by hsf - conflicts with\2\ninstall \1 /bin/true%' > /tmp/modemx_hsf.conflicts.conf
[ -s /tmp/modemx_hsf.conflicts.conf ] \
 && mv /tmp/modemx_hsf.conflicts.conf /etc/modprobe.d/ \
 || rm -f /tmp/modemx_hsf.conflicts.conf /etc/modprobe.d/modemx_hsf.conflicts.conf

#Edit config script to avoid device instances 1-7, avoid setting /dev/modem link, create modprobe configuration file. #120901
if [ -e /usr/sbin/hsfconfig ];then
 sed -e 's%^#\!/bin/bash$%#\!/bin/bash\n#Edited by Puppy Linux during extraction of firmware for modem initialization.%' \
  -e 's%while \[ $u -lt 8 \]; do%while [ $u -le 0 ]; do%' \
  -e 's%^[\ \	]*echo \"alias /dev/modem%#echo \"alias /dev/modem%' \
  -e 's%-[ef] /etc/modprobe.conf \]%& \&\& false%' \
  -e 's%if \[ -d /etc/udev/rules\.d \]; then%if [ -f /etc/udev/rules.d ]; then%' \
  -e 's%ln -sf /dev/ttyS...0 /dev/modem%/bin/true #&%' \
  -e 's%first=240%first=244%' \
  -e 's%max=249%max=251%' \
  -e 's%\tmajor=\${first}%\t[ "${device}" = "ttySDGC" -o  "${device}" = "cuaDGC" ] \\\n\t\t\&\& echo 0 \\\n\t\t\&\& return 0\n\n&%' \
  -e 's%\tunconfigure_rcscript || exit%#&%' \
  -e 's%\tremove_kernel_modules || exit%#&%' \
  -e 's%rm -f /dev/modem$%/bin/true #&%' \
  -e 's%mv /dev/modem /dev/modem.old$%/bin/true #&%' \
  -e 's%/etc/modprobe.d/hsf%/etc/modprobe.d/modem_hsf%g' \
  -e 's%/etc/modprobe.d/modem_hsf.conflicts%/etc/modprobe.d/modemx_hsf.conflicts%g' \
  /usr/sbin/hsfconfig > /usr/sbin/hsfconfig_adapted #120901
 chmod a+x /usr/sbin/hsfconfig_adapted #120901
 
 #Use edited config script to create devices and configuration file.
 /usr/sbin/hsfconfig_adapted --serial
fi
